#
# Author:

# Hans - Rainer Kloeckner
# MPIfR / Oxford
# hrk@mpifr-bonn.mpg.de
# hrk@astro.ox.ac.uk

#
# Copyright (c) 2011
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, see <http://www.gnu.org/licenses/>,
# or write to the Free Software Foundation, Inc., 
# 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
# 

def taskinscripts(directory='None'):
    """
    returns the individual AipsTask of all py files in the directory
    """
    findir = filesindir('.py',directory)
    #
    taskinfiles = []
    for i in range(len(findir)):
        if findir[i][findir[i].find('py'):] == 'py':
            if findir[i] != 'HRKinitAIPS.py':
                f = open(findir[i],"r")
                fl = f.readlines()
                for j in range(len(fl)):
                    if fl[j].find('AIPSTask(\'') > 0:
                        if taskinfiles.count(fl[j][fl[j].find('AIPSTask(\'')+10:].replace('\'','').replace(')\n','')) == 0:
                            taskinfiles.append(fl[j][fl[j].find('AIPSTask(\'')+10:].replace('\'','').replace(')\n',''))
                f.close()
    return(taskinfiles)

def initAIPSLite(outdiskname='aipsdisk',doaipslite=1,i_do_have_aips = 1):
    """
    internalise AIPS environment 
    """
    if doaipslite > 0:
        import os
        cwd = os.getcwd()
        import AIPSLite
        #
        if i_do_have_aips == 1:
            try:
                #
                path = os.environ['AIPS_ROOT']    
            except KeyError:
                import sys
                print  '\n\nAIPS has not been defined, please source your LOGIN.CSH\n'
                print 'You may want to use one of these files:\n'
                os.system('locate LOGIN.CSH')
                sys.exit(-1)
            else:
                path = os.environ['AIPS_ROOT']    
            # IF YOU HAVE AN AIPS INSTALATION ON YOUR COMPUTER USE and sourced LOGIN.CSH file 
            #
            AIPSLite.init_environ(path=os.environ['AIPS_ROOT'], version=os.environ['AIPS_VERSION'][len(os.environ['AIPS_VERSION'])-7:])
            #
            # make the AIPS directories 
            #

        else:
            #
            # IF YOU DON'T HAVE A AIPS VERSION INSTALLED 
            # 
            print  '\n\nThe default AIPS version ',AIPSLite.default_version,' will be downloaded.\n\n'
            #
            AIPSLite.init_environ(path=cwd, version=AIPSLite.default_version)
            #
            # Get all necessary Task's from NRAO
            #
            neededtask = taskinscripts()
            for i in range(len(neededtask)):
                AIPSLite.get_task(neededtask[i])                
            #
            AIPSLite.get_template()
            AIPSLite.get_popsdat()
            AIPSLite.get_libs()
            #
            os.environ['PLOTTER'] = '/tmp'
        #
        AIPSLite.make_da00(cwd+'/da00')
        AIPSLite.make_disk(cwd+'/'+outdiskname)
        #
        return(cwd)
